"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.saveEventsCustom = exports.saveEventsToRilog = void 0;
var constants_1 = require("../constants");
/**
 * Do save events to backend
 * @param data - encrypted events data(array)
 * @param token - authorization token for sending requests
 * @returns
 */
var saveEventsToRilog = function (data, token) {
    return fetch("".concat(constants_1.BASE_URL, "/connection/send"), {
        method: 'POST',
        headers: {
            'Content-Type': 'application/json',
            Authorization: "Bearer ".concat(token),
        },
        body: JSON.stringify({ eventsData: data }),
    })
        .then(function (response) { return response.json(); })
        .catch(function (error) {
        console.error('[Rilog-lib] Got error in save events to rilog (/connection/send) ', error);
    });
};
exports.saveEventsToRilog = saveEventsToRilog;
var saveEventsCustom = function (_a) {
    var data = _a.data, url = _a.url, headers = _a.headers;
    var updatedHeaders = new Headers();
    updatedHeaders.append('Content-Type', 'application/json');
    if (headers) {
        Object.keys(headers).forEach(function (key) {
            updatedHeaders.append(key, headers[key]);
        });
    }
    return fetch(url, {
        method: 'POST',
        headers: updatedHeaders,
        body: data,
    })
        .then(function (response) { return response.json(); })
        .catch(function (error) {
        console.error('[Rilog-lib] Got error in save events ', error);
    });
};
exports.saveEventsCustom = saveEventsCustom;
