import { IRilogMessageConfig } from '../feature/interceptors/message/types';
import { IRilog, TRilogExtensions, TRilogInit, TRilogPushRequest, TRilogPushResponse, TRilogState } from '../types';
declare class Rilog implements IRilog {
    private interceptor;
    private axiosAdapter;
    private fetchAdapter;
    private state;
    constructor(state: TRilogState, extensions?: TRilogExtensions);
    init({ key, config }: TRilogInit): Promise<void>;
    /**
     * Axios interception methods
     */
    interceptRequestAxios(data: TRilogPushRequest): void;
    interceptResponseAxios(data: TRilogPushResponse): Promise<void>;
    /**
     * Intercept custom user messages/data
     */
    saveData<T>(data: T, config: IRilogMessageConfig): void;
    /**
     * Fetch interception methods
     */
    private interceptFetchRequest;
    private interceptFetchResponse;
    /**
     * Update some part of state
     * @param state {object}
     */
    private updateState;
}
export default Rilog;
