"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("../api");
var adapter_1 = require("../feature/interceptors/axios/adapter");
var fetch_1 = require("../feature/interceptors/fetch");
var adapter_2 = require("../feature/interceptors/fetch/adapter");
var utils_1 = require("../utils");
var browser_1 = require("../utils/browser");
var logger_1 = require("../utils/logger");
var interceptor_1 = require("./interceptor");
var Rilog = /** @class */ (function () {
    function Rilog(state, extensions) {
        this.interceptor = null;
        this.state = state;
        this.axiosAdapter = new adapter_1.default();
        this.fetchAdapter = new adapter_2.default();
        /**
         * Check if extension is exist and starts it.
         */
        if (extensions === null || extensions === void 0 ? void 0 : extensions.interactivePanel) {
            extensions.interactivePanel.build();
        }
    }
    Rilog.prototype.init = function (_a) {
        var key = _a.key, config = _a.config;
        return __awaiter(this, void 0, void 0, function () {
            var uToken, externalInfo, data;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        /**
                         * Initialize interceptor
                         * Set default config from client to interceptor for relevant request filtering
                         */
                        this.interceptor = new interceptor_1.default(config || null);
                        /**
                         * Init fetch interception.
                         * (Can be disabled from config).
                         */
                        !(config === null || config === void 0 ? void 0 : config.disableFetchInterceptor) && (0, fetch_1.initFetchInterception)(this.interceptFetchRequest.bind(this), this.interceptFetchResponse.bind(this), config === null || config === void 0 ? void 0 : config.selfServer);
                        uToken = (0, utils_1.getUserUniqToken)();
                        /**
                         * Save appId (app key) to the state
                         */
                        key && this.updateState({ key: key });
                        externalInfo = (0, browser_1.getExternalInfo)();
                        return [4 /*yield*/, (0, api_1.initRequest)({ data: { uToken: uToken, appId: key !== null && key !== void 0 ? key : '', externalInfo: externalInfo }, config: config })];
                    case 1:
                        data = _b.sent();
                        this.updateState({
                            token: data.access_token,
                            salt: data.salt,
                            recording: data.recording,
                            init: true,
                            config: config || null,
                        });
                        /**
                         * Set salt and acess token to interceptop for pushing it to backend store
                         */
                        this.interceptor.salt = data.salt;
                        this.interceptor.token = data.access_token;
                        this.interceptor.init = true;
                        this.interceptor.uToken = uToken;
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Axios interception methods
     */
    Rilog.prototype.interceptRequestAxios = function (data) {
        if (this.state.init && !this.state.recording)
            return;
        /**
         * Prepare request from axios
         */
        var axiosPreparedRequest = this.axiosAdapter.getRequest(data);
        if (!axiosPreparedRequest || !this.interceptor)
            return;
        this.interceptor.onRequest(axiosPreparedRequest);
    };
    Rilog.prototype.interceptResponseAxios = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var axiosPreparedResponse;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.state.init && !this.state.recording)
                            return [2 /*return*/];
                        axiosPreparedResponse = this.axiosAdapter.getResponse(data);
                        if (!axiosPreparedResponse || !this.interceptor)
                            return [2 /*return*/];
                        return [4 /*yield*/, this.interceptor.onResponse(axiosPreparedResponse)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Intercept custom user messages/data
     */
    Rilog.prototype.saveData = function (data, config) {
        var _a;
        (_a = this.interceptor) === null || _a === void 0 ? void 0 : _a.onSaveData(data, config);
    };
    /**
     * Fetch interception methods
     */
    Rilog.prototype.interceptFetchRequest = function (data) {
        if (this.state.init && !this.state.recording)
            return;
        /**
         * Prepare request from fetch
         */
        var fetchPreparedRequest = this.fetchAdapter.getRequest(data);
        if (!fetchPreparedRequest || !this.interceptor)
            return;
        this.interceptor.onRequest(fetchPreparedRequest);
    };
    Rilog.prototype.interceptFetchResponse = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var fetchPreparedResponse;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.state.init && !this.state.recording)
                            return [2 /*return*/];
                        fetchPreparedResponse = this.fetchAdapter.getResponse(data);
                        if (!fetchPreparedResponse || !this.interceptor)
                            return [2 /*return*/];
                        return [4 /*yield*/, this.interceptor.onResponse(fetchPreparedResponse)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update some part of state
     * @param state {object}
     */
    Rilog.prototype.updateState = function (state) {
        var updatedState = __assign(__assign({}, this.state), state);
        this.state = updatedState;
    };
    var _a;
    __decorate([
        (0, logger_1.logMethods)('IRilog'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], Rilog.prototype, "init", null);
    __decorate([
        (0, logger_1.logMethods)('IRilog'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], Rilog.prototype, "interceptRequestAxios", null);
    __decorate([
        (0, logger_1.logMethods)('IRilog'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [typeof (_a = typeof T !== "undefined" && T) === "function" ? _a : Object, Object]),
        __metadata("design:returntype", void 0)
    ], Rilog.prototype, "saveData", null);
    __decorate([
        (0, logger_1.logMethods)('IRilog'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], Rilog.prototype, "interceptFetchRequest", null);
    __decorate([
        (0, logger_1.logMethods)('IRilog'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], Rilog.prototype, "interceptFetchResponse", null);
    return Rilog;
}());
exports.default = Rilog;
