"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var filters_1 = require("../utils/filters");
var RilogFilterRequest = /** @class */ (function () {
    function RilogFilterRequest(config) {
        this.config = config;
    }
    RilogFilterRequest.prototype.getRequests = function (data) {
        var filteredRequest = null;
        filteredRequest = this.sensetive(data);
        filteredRequest = this.sensetiveData(filteredRequest);
        filteredRequest = this.headers(filteredRequest);
        filteredRequest = this.storage(filteredRequest);
        return filteredRequest;
    };
    RilogFilterRequest.prototype.isLibruaryRequest = function (data) {
        return (0, filters_1.isLibruarySensetiveRequest)(data.url);
    };
    RilogFilterRequest.prototype.isIgnoredRequest = function (data) {
        var _a;
        if (!((_a = this.config) === null || _a === void 0 ? void 0 : _a.ignoredRequests))
            return false;
        return (0, filters_1.isUrlIgnored)(data.url, this.config.ignoredRequests);
    };
    RilogFilterRequest.prototype.sortEventsByDate = function (events) {
        return events.sort(function (a, b) { return +a.date - +b.date; });
    };
    RilogFilterRequest.prototype.sensetive = function (data) {
        var _a, _b;
        return ((_b = (_a = this.config) === null || _a === void 0 ? void 0 : _a.sensetiveRequsts) === null || _b === void 0 ? void 0 : _b.some(function (sensetiveUrl) { return data.url.toLowerCase().includes(sensetiveUrl.toLowerCase()); })) ? __assign(__assign({}, data), { headers: 'sensetive', data: 'sensetive' }) : data;
    };
    RilogFilterRequest.prototype.sensetiveData = function (data) {
        var _a, _b;
        return ((_b = (_a = this.config) === null || _a === void 0 ? void 0 : _a.sensetiveDataRequests) === null || _b === void 0 ? void 0 : _b.some(function (sensetiveUrl) { return data.url.toLowerCase().includes(sensetiveUrl.toLowerCase()); })) ? __assign(__assign({}, data), { data: 'sensetive' }) : data;
    };
    RilogFilterRequest.prototype.headers = function (data) {
        var _a, _b, _c;
        var headers = {};
        if (data.headers === 'sensetive') {
            return data;
        }
        (_b = (_a = this.config) === null || _a === void 0 ? void 0 : _a.headers) === null || _b === void 0 ? void 0 : _b.map(function (header) {
            var _a;
            headers = __assign(__assign({}, headers), (_a = {}, _a[header] = data.headers[header], _a));
        });
        return __assign(__assign({}, data), { headers: ((_c = this.config) === null || _c === void 0 ? void 0 : _c.headers) ? headers : data.headers });
    };
    RilogFilterRequest.prototype.storage = function (data) {
        var _a;
        var localStorageConfig = ((_a = this.config) === null || _a === void 0 ? void 0 : _a.localStorage) || null;
        if (localStorageConfig) {
            var resultLocalStorage_1 = null;
            var localStorageData_1 = data.localStorage ? JSON.parse(data.localStorage) : null;
            if (!localStorageData_1) {
                return __assign(__assign({}, data), { localStorage: '' });
            }
            localStorageConfig.forEach(function (item) {
                var _a, _b;
                if (localStorageData_1[item]) {
                    if (resultLocalStorage_1) {
                        resultLocalStorage_1 = __assign(__assign({}, resultLocalStorage_1), (_a = {}, _a[item] = localStorageData_1[item], _a));
                    }
                    else {
                        resultLocalStorage_1 = (_b = {}, _b[item] = localStorageData_1[item], _b);
                    }
                }
            });
            return __assign(__assign({}, data), { localStorage: resultLocalStorage_1 || '' });
        }
        else {
            return __assign(__assign({}, data), { localStorage: '' });
        }
    };
    return RilogFilterRequest;
}());
exports.default = RilogFilterRequest;
