import { IRilogMessageConfig } from '../feature/interceptors/message/types';
import { IRilogRequest, IRilogResponse, TRilogInitConfig, TRilogState } from '../types';
import { IRilogInterceptorState, IRilogInterceptror } from '../types/interceptor';
declare class RilogInterceptor implements IRilogInterceptror {
    private clickInterceptor;
    private messageInterceptor;
    private timer;
    private filter;
    private config;
    init: TRilogState['init'];
    salt: TRilogState['salt'];
    token: TRilogState['token'];
    uToken: string | null;
    state: IRilogInterceptorState;
    constructor(config: TRilogInitConfig | null);
    onSaveData<T>(data: T, config: IRilogMessageConfig): void;
    onClick(event: any): void;
    onRequest(request: IRilogRequest): void;
    onResponse(response: IRilogResponse): Promise<void>;
    private pushEvents;
    private saveEvents;
    /**
     * Define the send events methods using some config params.
     * @param {TSendEvents}
     * @returns {Promise}
     */
    private sendEvents;
}
export default RilogInterceptor;
