"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("../api");
var constants_1 = require("../constants");
var click_1 = require("../feature/interceptors/click");
var utils_1 = require("../feature/interceptors/click/utils");
var constants_2 = require("../feature/interceptors/constants");
var message_1 = require("../feature/interceptors/message");
var events_1 = require("../types/events");
var utils_2 = require("../utils");
var encrypt_1 = require("../utils/encrypt");
var filterRequest_1 = require("./filterRequest");
var timer_1 = require("./timer");
var filters_1 = require("../utils/filters");
var RilogInterceptor = /** @class */ (function () {
    function RilogInterceptor(config) {
        this.config = null;
        this.init = false;
        this.salt = null;
        this.token = null;
        this.uToken = null;
        this.state = constants_2.defaultState;
        this.config = config;
        this.timer = new timer_1.default();
        this.filter = new filterRequest_1.default(config);
        this.clickInterceptor = new click_1.default();
        this.messageInterceptor = new message_1.default();
        /**
         * The click interception can be disabled by user from config.
         */
        if (!(config === null || config === void 0 ? void 0 : config.disableClickInterceptor))
            window.document.addEventListener('click', this.onClick.bind(this));
    }
    RilogInterceptor.prototype.onSaveData = function (data, config) {
        var _a;
        var messageEvent = (_a = this.messageInterceptor) === null || _a === void 0 ? void 0 : _a.getMessageEvent(data, config);
        this.pushEvents(messageEvent);
    };
    RilogInterceptor.prototype.onClick = function (event) {
        var _a, _b;
        if ((_a = this.config) === null || _a === void 0 ? void 0 : _a.disableClickInterceptor)
            return;
        if ((0, utils_1.isButtonElement)(event)) {
            var clickEvent = (_b = this.clickInterceptor) === null || _b === void 0 ? void 0 : _b.getClickEvent(event);
            clickEvent && this.pushEvents(clickEvent);
        }
    };
    RilogInterceptor.prototype.onRequest = function (request) {
        var _this = this;
        var _a, _b;
        var timedRequest = request
            ? __assign(__assign({}, request), { timestamp: Date.now(), 
                // should be defined in request time
                location: (0, utils_2.getLocation)(), localStorage: JSON.stringify(localStorage) }) : null;
        /**
         * Shor timer is used only for interception request-response. It's time without any response from server.
         */
        this.timer.startShort(function () {
            _this.onResponse({});
        });
        if (!timedRequest)
            return;
        /**
         * Check if request was to self server and skip onRequest if true (this req shouldn't be logged).
         */
        var isSelfServerRequest = ((_a = this.config) === null || _a === void 0 ? void 0 : _a.selfServer) ? (0, filters_1.isUrlIgnored)(timedRequest.url, [(_b = this.config) === null || _b === void 0 ? void 0 : _b.selfServer.url]) : false;
        if (isSelfServerRequest)
            return;
        if (this.filter.isLibruaryRequest(timedRequest) || this.filter.isIgnoredRequest(timedRequest))
            return;
        this.state.request = this.filter.getRequests(timedRequest) || null;
    };
    RilogInterceptor.prototype.onResponse = function (response) {
        return __awaiter(this, void 0, void 0, function () {
            var fullRequest, timedResponse;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fullRequest = null;
                        timedResponse = response ? __assign(__assign({}, response), { timestamp: Date.now() }) : null;
                        this.timer.clearShort();
                        /**
                         * Can't prepare any response without request.
                         */
                        if (!this.state.request)
                            return [2 /*return*/];
                        fullRequest = timedResponse
                            ? {
                                _id: (0, utils_2.generateUniqueId)(),
                                request: this.state.request,
                                response: timedResponse,
                            }
                            : {
                                _id: (0, utils_2.generateUniqueId)(),
                                request: this.state.request,
                                response: {
                                    data: 'No response from server. Timeout.',
                                    status: '',
                                    timestamp: Date.now(),
                                },
                            };
                        /**
                         * Clear long timer which was started after pushing request data to server.
                         */
                        this.timer.clearLong();
                        return [4 /*yield*/, this.pushEvents({
                                _id: (0, utils_2.generateUniqueId)(),
                                type: events_1.ERilogEvent.REQUEST,
                                date: fullRequest.request.timestamp.toString(),
                                data: fullRequest,
                                location: fullRequest.request.location,
                            })];
                    case 1:
                        _a.sent();
                        /**
                         * Clear request data
                         */
                        this.state.request = null;
                        return [2 /*return*/];
                }
            });
        });
    };
    RilogInterceptor.prototype.pushEvents = function (data) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var events, eventsArray;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        /**
                         * User can intercept push events to array using callback from config.
                         */
                        if ((_a = this.config) === null || _a === void 0 ? void 0 : _a.onPushEvent)
                            (_b = this.config) === null || _b === void 0 ? void 0 : _b.onPushEvent(data);
                        events = localStorage.getItem(constants_1.RIL_EVENTS);
                        eventsArray = events ? JSON.parse(events) : [];
                        if (!eventsArray) return [3 /*break*/, 4];
                        eventsArray.push(data);
                        if (!(eventsArray.length > constants_1.EVENTS_ARRAY_LIMIT || (0, utils_2.isFullLocalStorage)(events))) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.saveEvents(eventsArray)];
                    case 1:
                        _c.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        localStorage.removeItem(constants_1.RIL_EVENTS);
                        localStorage.setItem(constants_1.RIL_EVENTS, JSON.stringify(eventsArray));
                        /**
                         * Leave function if lib isn't init
                         * (Lib got salt and token from backend on init request)
                         */
                        if (!this.init)
                            return [2 /*return*/];
                        this.timer.startLong(function () { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.saveEvents(eventsArray)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        _c.label = 3;
                    case 3: return [3 /*break*/, 5];
                    case 4:
                        localStorage.setItem(constants_1.RIL_EVENTS, JSON.stringify([data]));
                        _c.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    RilogInterceptor.prototype.saveEvents = function (data) {
        var _a, _b, _c, _d, _e;
        return __awaiter(this, void 0, void 0, function () {
            var sortedEvents, encryptedEvents, result;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        /**
                         * Users can intercept events using callback from config.
                         */
                        if ((_a = this.config) === null || _a === void 0 ? void 0 : _a.onSaveEvents)
                            (_b = this.config) === null || _b === void 0 ? void 0 : _b.onSaveEvents(data);
                        sortedEvents = this.filter.sortEventsByDate(data);
                        encryptedEvents = (0, encrypt_1.encrypt)(sortedEvents, this.salt);
                        return [4 /*yield*/, this.sendEvents({ data: encryptedEvents, token: this.token || '', localServer: (_c = this.config) === null || _c === void 0 ? void 0 : _c.localServer, selfServer: (_d = this === null || this === void 0 ? void 0 : this.config) === null || _d === void 0 ? void 0 : _d.selfServer })];
                    case 1:
                        result = _f.sent();
                        this.timer.clearLong();
                        if (((_e = result === null || result === void 0 ? void 0 : result.result) === null || _e === void 0 ? void 0 : _e.toLowerCase()) === 'success') {
                            localStorage.removeItem(constants_1.RIL_EVENTS);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Define the send events methods using some config params.
     * @param {TSendEvents}
     * @returns {Promise}
     */
    RilogInterceptor.prototype.sendEvents = function (_a) {
        var _b;
        var data = _a.data, token = _a.token, localServer = _a.localServer, selfServer = _a.selfServer;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                /**
                 * The priority method for saving is local :)
                 */
                if (localServer) {
                    return [2 /*return*/, (0, api_1.saveEventsCustom)({ data: JSON.stringify(__assign({ events: data, uToken: this.uToken }, (_b = this.config) === null || _b === void 0 ? void 0 : _b.localServer)), url: "".concat(constants_1.LOCAL_BASE_URL, "/api/events/save") })];
                }
                if (selfServer) {
                    return [2 /*return*/, (0, api_1.saveEventsCustom)({ data: JSON.stringify({ events: data }), url: selfServer.url, headers: selfServer.headers })];
                }
                return [2 /*return*/, (0, api_1.saveEventsToRilog)(data, token)];
            });
        });
    };
    return RilogInterceptor;
}());
exports.default = RilogInterceptor;
