"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../../../constants");
var AxiosAdapter = /** @class */ (function () {
    function AxiosAdapter() {
    }
    AxiosAdapter.prototype.getRequest = function (data) {
        var requestFull = {
            url: '',
            method: '',
            headers: {},
            data: {},
            location: { origin: null, href: null },
            localStorage: null,
        };
        // Fill Request data
        (data === null || data === void 0 ? void 0 : data.url) && (requestFull = __assign(__assign({}, requestFull), { url: data.url }));
        (data === null || data === void 0 ? void 0 : data.method) && (requestFull = __assign(__assign({}, requestFull), { method: data.method }));
        (data === null || data === void 0 ? void 0 : data.headers) && (requestFull = __assign(__assign({}, requestFull), { headers: data.headers }));
        (data === null || data === void 0 ? void 0 : data.data) && (requestFull = __assign(__assign({}, requestFull), { data: data.data }));
        (data === null || data === void 0 ? void 0 : data.params) && (requestFull = __assign(__assign({}, requestFull), { data: __assign(__assign({}, requestFull.data), data.params) }));
        return this.checkEmptyRequest(requestFull) ? null : requestFull;
    };
    AxiosAdapter.prototype.getResponse = function (data) {
        var _a, _b, _c, _d, _e;
        var responseFull = {
            data: {},
            status: null,
        };
        if (Object.keys(data).length === 0) {
            return null;
        }
        if (((_a = data === null || data === void 0 ? void 0 : data.status) === null || _a === void 0 ? void 0 : _a.toString()[0]) !== constants_1.SUCCESS_RESPONSE_STATUS_START_CODE) {
            return { data: data.response.data, status: (_b = data.status) === null || _b === void 0 ? void 0 : _b.toString() };
        }
        if (data === null || data === void 0 ? void 0 : data.data) {
            responseFull = __assign(__assign({}, responseFull), { data: data.data, status: ((_d = (_c = data === null || data === void 0 ? void 0 : data.response) === null || _c === void 0 ? void 0 : _c.status) === null || _d === void 0 ? void 0 : _d.toString()) || ((_e = data === null || data === void 0 ? void 0 : data.status) === null || _e === void 0 ? void 0 : _e.toString()) || null });
        }
        return this.checkEmptyResponse(responseFull) ? null : responseFull;
    };
    AxiosAdapter.prototype.checkEmptyRequest = function (request) {
        var empty = false;
        !request.url && (empty = true);
        !request.method && (empty = true);
        !request.headers && (empty = true);
        return empty;
    };
    AxiosAdapter.prototype.checkEmptyResponse = function (response) {
        var empty = false;
        Object.keys(response.data).length === 0 && (empty = true);
        return empty;
    };
    return AxiosAdapter;
}());
exports.default = AxiosAdapter;
