"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("../../../types/events");
var utils_1 = require("../../../utils");
var logger_1 = require("../../../utils/logger");
var constants_1 = require("./constants");
var constants_2 = require("../../../constants");
var ClickInterceptor = /** @class */ (function () {
    function ClickInterceptor() {
    }
    ClickInterceptor.prototype.getClickEvent = function (event) {
        var _a, _b, _c, _d;
        var id = ((_a = this.getParentButton(event.target)) === null || _a === void 0 ? void 0 : _a.id) || event.target.id;
        if (id && constants_2.SELF_SENSETIVE_CLICK_IDS.some(function (selfId) { return id.includes(selfId); }))
            return;
        var elementInfo = {
            inner: ((_b = this.getParentButton(event.target)) === null || _b === void 0 ? void 0 : _b.innerHTML) || event.target.innerHTML,
            nodeName: ((_c = this.getParentButton(event.target)) === null || _c === void 0 ? void 0 : _c.nodeName) || event.target.nodeName,
            classNames: ((_d = this.getParentButton(event.target)) === null || _d === void 0 ? void 0 : _d.className) || event.target.className,
            id: id,
        };
        return {
            _id: (0, utils_1.generateUniqueId)(),
            type: events_1.ERilogEvent.CLICK,
            date: Date.now().toString(),
            data: elementInfo,
            location: (0, utils_1.getLocation)(),
        };
    };
    /**
     * Return HTMLElement if parent is button element. In case when click was on inner element (not button).
     * @param target
     * @returns
     */
    ClickInterceptor.prototype.getParentButton = function (target) {
        if (constants_1.BUTTON_NODES.includes(target.tagName.toLowerCase()))
            return target;
        if (!target.parentElement || !constants_1.BUTTON_NODES.includes(target.parentElement.tagName.toLowerCase()))
            return;
        return target.parentElement;
    };
    __decorate([
        (0, logger_1.logMethods)('ClickInterceptor', true),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Object)
    ], ClickInterceptor.prototype, "getClickEvent", null);
    return ClickInterceptor;
}());
exports.default = ClickInterceptor;
