"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var transforms_1 = require("../../../utils/transforms");
var FetchAdapter = /** @class */ (function () {
    function FetchAdapter() {
    }
    FetchAdapter.prototype.getRequest = function (data) {
        var _a, _b, _c, _d;
        var queryParams = (0, transforms_1.getQueryParamsFromUrl)(data.url);
        var requestFull = {
            url: data.url,
            method: ((_a = data.options) === null || _a === void 0 ? void 0 : _a.method) || 'GET',
            headers: ((_b = data.options) === null || _b === void 0 ? void 0 : _b.headers) || {},
            data: ((_c = data.options) === null || _c === void 0 ? void 0 : _c.method) ? (_d = data.options) === null || _d === void 0 ? void 0 : _d.data : queryParams || {},
            location: { origin: null, href: null },
            localStorage: null,
        };
        return this.checkEmptyRequest(requestFull) ? null : requestFull;
    };
    FetchAdapter.prototype.getResponse = function (data) {
        if (Object.keys(data).length === 0) {
            return null;
        }
        var responseFull = {
            data: data.data || 'No data.',
            status: data.status || null,
        };
        return responseFull;
    };
    FetchAdapter.prototype.checkEmptyRequest = function (request) {
        var empty = false;
        !request.url && (empty = true);
        !request.method && (empty = true);
        return empty;
    };
    return FetchAdapter;
}());
exports.default = FetchAdapter;
