import { IRilogRequestItem } from './requests';
import { IRilogClick } from '../feature/interceptors/click/types';
import { IRilogMessageData } from '../feature/interceptors/message/types';
import { IRilogInput } from '../feature/interceptors/input/types';
/**
 * Different types of events.
 * !!!Should be updated with BACKEND types
 */
export declare enum ERilogEvent {
    REQUEST = 0,
    CLICK = 1,
    INPUT = 2,
    CONSOLE_ERROR = 3,
    DEBUG_MESSAGE = 4
}
export interface IRilogLocation {
    origin: string | null;
    href: string | null;
}
/**
 * !!!Should be updated with BACKEND types
 */
export interface IRilogEventItem {
    _id: string;
    type: ERilogEvent;
    date: string;
    data: IRilogRequestItem | IRilogClick | IRilogMessageData | IRilogInput;
    location: IRilogLocation;
}
