"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.logMethods = void 0;
/**
 * Create a decorator function for logging
 */
var logMethods = function (label, showArgs) {
    if (showArgs === void 0) { showArgs = false; }
    return function (target, memberName, descriptor) {
        /**
         * Get the original method
         */
        var originalMethod = descriptor.value;
        /**
         * Modify the descriptor to wrap the original method
         */
        descriptor.value = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            /**
             *  Log method name and parameters
             */
            console.log("[Rilog-lib debug] (".concat(label, "|").concat(memberName, "):"), showArgs && JSON.stringify(args));
            /**
             * Call the original method
             */
            return originalMethod.apply(this, args);
        };
        return descriptor;
    };
};
exports.logMethods = logMethods;
