"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateUniqueId = exports.getUserUniqToken = void 0;
var constants_1 = require("../constants");
/**
 * Generate unique token. Mostly it uses for generation personal client token (dependents on browser).
 * @return {string} unique token
 */
var generateToken = function () {
    var rand = function () { return Math.random().toString(32).substr(2); };
    return rand() + rand() + rand();
};
/**
 * Generate unique id. Mostly it uses for id in the event object.
 * @return {string} unique id
 */
var generateUniqueId = function () {
    // Random number to make the ID unique
    var randomNumber = Math.random().toString(36).substr(2, 9);
    // Timestamp to ensure uniqueness even in case of concurrent calls
    var timestamp = Date.now().toString(36);
    // Combine random number and timestamp
    return randomNumber + timestamp;
};
exports.generateUniqueId = generateUniqueId;
/**
 * Set token for each not auth user for unique user registration
 * (here unique user mean open app in browser,
 * also user can enter self unique token is spec input for auth in another browser/device )
 * @return {string} client unique token
 */
var getUserUniqToken = function () {
    var savedToken = localStorage === null || localStorage === void 0 ? void 0 : localStorage.getItem(constants_1.RIL_TOKEN);
    if (savedToken) {
        return savedToken;
    }
    else {
        var token = generateToken();
        localStorage.setItem(constants_1.RIL_TOKEN, token);
        return token;
    }
};
exports.getUserUniqToken = getUserUniqToken;
